<div class="file-upload-wrapper">
  <form class="file-upload-flex">
    <!-- OPTIONS COLUMN -->
    <div class="file-upload-column file-upload-options">
      <!-- Upload-type selector -->
      <ng-container *ngIf="this.parentDataItem.type != 'FOLDER'">
        <div class="divider-line">Upload</div>
        <mat-form-field class="file-upload-form-field">
          <mat-label>Upload Type</mat-label>
          <mat-select [(value)]="this.dataUploadModeSelection"
                      (selectionChange)="dataUploadModeSelectionChange($event.value)">
            <mat-option *ngFor="let dataMode of dataUploadModeOptions"
                        [value]="dataMode">{{ dataMode }}
            </mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <!-- Data Selection: Result Upload -->
      <ng-container *ngIf="this.dataUploadModeSelection == 'Result Upload'">
        <mat-form-field class="file-upload-form-field">
          <mat-label>Data Type</mat-label>
          <mat-select [(value)]="this.dataUploadSelection" (selectionChange)="onUploadSelectionChange($event.value)">
            <mat-option *ngFor="let fileType of dataUploadOptions" [value]="fileType">{{ fileType }}</mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <!-- ProteinDatabase -->
      <ng-container
        *ngIf="(this.dataUploadModeSelection == 'Result Upload' && this.dataUploadSelection == 'Search Result') || this.dataUploadModeSelection.startsWith('Search')">
        <!-- TODO: fix position of this for experiment-component, so it does not move around. BUT has to be at the top for folder-component -->
        <div class="divider-line">ProteinDB</div>
        <mat-form-field class="file-upload-form-field">
          <mat-label>Protein Database</mat-label>
          <mat-select [(value)]="this.proteinDBselection" (selectionChange)="onProteinDBChange($event.value)">
            <mat-option *ngFor="let protDB of proteinDatabases" [value]="protDB">{{ protDB.displayName }}</mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>

      <!-- Spectral Library -->
      <ng-container *ngIf="this.dataUploadModeSelection == 'Search DIA'">
        <div class="divider-line">Spectral Library</div>
        <mat-form-field class="file-upload-form-field">
          <mat-label>Spectral Library</mat-label>
          <mat-select [(value)]="this.spectralLibrarySelection">
            <mat-option *ngFor="let specLib of this.spectralLibraries" [value]="specLib">{{ specLib.name }}</mat-option>
          </mat-select>
        </mat-form-field>
      </ng-container>
    </div>

    <!-- Peaklist -->
    <ng-container
      *ngIf="this.dataUploadModeSelection.startsWith('Search') || this.dataUploadSelection == 'Peaklist + Search Result'">
      <div class="file-upload-column">
        <div class="divider-line">Peaklist</div>

        <mat-form-field class="file-upload-form-field">
          <mat-label>Peaklist Type</mat-label>
          <mat-select [(value)]="this.peaklistSelection" (selectionChange)="onFileTypeSelectionChange()">
            <mat-option *ngFor="let fileType of uploadFileTypePeaklist" [value]="fileType">{{ fileType }}</mat-option>
          </mat-select>
        </mat-form-field>
        <!-- Dropzone -->
        <!-- <app-file-dropzone [allowMultiple]="this.dataUploadModeSelection == 'Search'"
            [acceptedFileTypes]="this.peaklistSelection == 'MZML' ? ['.mzml'] : ['.mgf']"
            (fileInputEvent)="this.peaklistFileInput($event)"
            [selectedFiles]="this.selectedPeaklistFiles"></app-file-dropzone> -->
        <app-file-dropzone [allowMultiple]="this.dataUploadModeSelection == 'Search DDA'"
                           [acceptedFileTypes]="['.mgf']"
                           (fileInputEvent)="this.peaklistFileInput($event)"
                           [selectedFiles]="this.selectedPeaklistFiles"></app-file-dropzone>
      </div>
    </ng-container>

    <!-- Search Parameters DDA -->
    <ng-container *ngIf="this.dataUploadModeSelection == 'Search DDA'">
      <div class="file-upload-column">
        <div class="divider-line">Search Parameters</div>
        <!-- Precursor ion tolerance -->
        <div class="file-upload-grid-input-with-selector">
          <mat-form-field>
            <mat-label>Precursor Ion Tolerance</mat-label>
            <!-- ppm -->
            <ng-container *ngIf="this.searchParameters.precursorIonToleranceUnitSelection == 'ppm'">
              <input matInput type="number" min="0" max="1000" step="1" placeholder="0 to 1000 ppm"
                     name="precursorTolerance"
                     (blur)="this.searchParameters.checkToleranceInput(this.searchParameters.precursorIonToleranceUnitSelection, this.searchParameters.precursorIonTolerance, 'precursorIonTolerance')"
                     [(ngModel)]="searchParameters.precursorIonTolerance">
            </ng-container>

            <!-- Da -->
            <ng-container *ngIf="this.searchParameters.precursorIonToleranceUnitSelection == 'Da'">
              <input matInput type="number" min="0" max="10" step="0.001" placeholder="0.001 to 1 Da"
                     name="precursorTolerance"
                     (blur)="searchParameters.checkToleranceInput(this.searchParameters.precursorIonToleranceUnitSelection, this.searchParameters.precursorIonTolerance, 'precursorIonTolerance')"
                     [(ngModel)]="searchParameters.precursorIonTolerance">
            </ng-container>
          </mat-form-field>
          <!-- unit-selection -->
          <mat-form-field>
            <mat-select [(value)]="this.searchParameters.precursorIonToleranceUnitSelection">
              <mat-option *ngFor="let unit of searchParameters.precursorIonToleranceUnitOptions"
                          [value]="unit"
                          (onSelectionChange)="searchParameters.unitSelectionChange(unit, 'precursorIonTolerance')">
                {{ unit }}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>

        <!-- Fragment Ion Tolerance -->
        <div class="file-upload-grid-input-with-selector">
          <mat-form-field>
            <mat-label>Fragment Ion Tolerance</mat-label>
            <!-- ppm -->
            <ng-container *ngIf="this.searchParameters.fragmentIonToleranceUnitSelection == 'ppm'">
              <input matInput type="number" min="0" max="1000" step="1" placeholder="0 to 1000 ppm"
                     name="fragmentTolerance"
                     (blur)="searchParameters.checkToleranceInput(this.searchParameters.fragmentIonToleranceUnitSelection, this.searchParameters.fragmentIonTolerance, 'fragmentIonTolerance')"
                     [(ngModel)]="searchParameters.fragmentIonTolerance">
            </ng-container>
            <!-- Da -->
            <ng-container *ngIf="this.searchParameters.fragmentIonToleranceUnitSelection == 'Da'">
              <input matInput type="number" min="0" max="10" step="0.001" placeholder="0.001 to 1 Da"
                     name="fragmentTolerance"
                     (blur)="this.searchParameters.checkToleranceInput(this.searchParameters.fragmentIonToleranceUnitSelection, this.searchParameters.fragmentIonTolerance, 'fragmentIonTolerance')"
                     [(ngModel)]="searchParameters.fragmentIonTolerance">
            </ng-container>
          </mat-form-field>
          <!-- unit-selection -->
          <mat-form-field>
            <mat-select [(value)]="this.searchParameters.fragmentIonToleranceUnitSelection">
              <mat-option *ngFor="let unit of searchParameters.fragmentIonToleranceUnitOptions" [value]="unit"
                          (onSelectionChange)="this.searchParameters.unitSelectionChange(unit, 'fragmentIonTolerance')">
                {{ unit }}
              </mat-option>
            </mat-select>
          </mat-form-field>
        </div>

        <!--            Advanced Search Parameters           -->
        <div>
          <!-- Divider + expansion-button -->
          <div style="display: flex; align-items:center; width:100%;">
            <div class="divider-line" style="width:100%;">Advanced Parameters</div>
            <button style="display: inline-block;" mat-icon-button (click)="expandAdvancedSearchParameters()">
              <mat-icon [@indicatorRotate]="advancedSearchExpanded ? 'expanded' : 'collapsed'">
                expand_more
              </mat-icon>
            </button>
          </div>

          <!-- TODO -->
          <div [@detailExpand]="advancedSearchExpanded ? 'expanded' : 'collapsed'"
               style="height:100%; width:100%; overflow: hidden">
            <mat-form-field class="file-upload-form-field">
              <mat-label>Carbamidomethylation</mat-label>
              <input matInput type="text" name="parameter1" placeholder="Parameter1">
            </mat-form-field>
            <mat-form-field class="file-upload-form-field">
              <mat-label>Oxidation</mat-label>
              <input matInput type="text" name="parameter2" placeholder="Parameter2">
            </mat-form-field>
          </div>
        </div>
      </div>
    </ng-container>

    <!-- Search Parameters DIA -->
    <ng-container *ngIf="this.dataUploadModeSelection == 'Search DIA'">
      <div class="file-upload-column">
        <div class="divider-line">Search Parameters</div>
        <div>
          <mat-form-field class="file-upload-form-field">
            <mat-label>Ion Tolerance in DA</mat-label>
            <ng-container>
              <input matInput type="number" min="0" max="1" step="0.001" placeholder="0.001 to 1 Da"
                     name="ionToleracnce"
                     (blur)="ruminationSearchParameters.checkToleranceInput(this.ruminationSearchParameters.ionToleracnce)"
                     [(ngModel)]="ruminationSearchParameters.ionToleracnce">
            </ng-container>

          </mat-form-field>
        </div>
        <div>
          <mat-form-field class="file-upload-form-field">
            <mat-label>Minimum Intensity Threshhold</mat-label>
            <ng-container>
              <input matInput type="number" min="0" max="1000" step="1" placeholder="0 to 1000"
                     name="intensityThreshold"
                     [(ngModel)]="ruminationSearchParameters.intensityThreshold">
            </ng-container>
          </mat-form-field>
        </div>

        <!--            Advanced Search Parameters           -->
        <!--          <div>-->
        <!--            &lt;!&ndash; Divider + expansion-button &ndash;&gt;-->
        <!--            <div style="display: flex; align-items:center; width:100%;">-->
        <!--              <div class="divider-line" style="width:100%;">Advanced Parameters</div>-->
        <!--              <button style="display: inline-block;" mat-icon-button (click)="expandAdvancedSearchParameters()">-->
        <!--                <mat-icon [@indicatorRotate]="advancedSearchExpanded ? 'expanded' : 'collapsed'">-->
        <!--                  expand_more-->
        <!--                </mat-icon>-->
        <!--              </button>-->
        <!--            </div>-->

        <!--            &lt;!&ndash; TODO &ndash;&gt;-->
        <!--            <div [@detailExpand]="advancedSearchExpanded ? 'expanded' : 'collapsed'"-->
        <!--                 style="height:100%; width:100%; overflow: hidden">-->
        <!--              <mat-form-field class="file-upload-form-field">-->
        <!--                <mat-label>Carbamidomethylation</mat-label>-->
        <!--                <input matInput type="text" name="parameter1" placeholder="Parameter1">-->
        <!--              </mat-form-field>-->
        <!--              <mat-form-field class="file-upload-form-field">-->
        <!--                <mat-label>Oxidation</mat-label>-->
        <!--                <input matInput type="text" name="parameter2" placeholder="Parameter2">-->
        <!--              </mat-form-field>-->
        <!--            </div>-->
        <!--          </div>-->
      </div>
    </ng-container>

    <!--            Search Result           -->
    <ng-container *ngIf="this.dataUploadModeSelection == 'Result Upload'">
      <div class="file-upload-column">
        <div class="divider-line">Search Result</div>
        <!-- filetype -->
        <mat-form-field class="file-upload-form-field">
          <mat-label>Search Result Data Type</mat-label>
          <mat-select [(value)]="this.searchFileSelection" (selectionChange)="onFileTypeSelectionChange()">
            <mat-option *ngFor="let fileType of uploadFileTypeSearch" [value]="fileType">
              {{ fileType }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <!-- DROPZONES -->
        <ng-container *ngIf="this.searchFileSelection == 'MZID'">
          <app-file-dropzone [allowMultiple]="true"
                             [acceptedFileTypes]="['.mzid']"
                             (fileInputEvent)="this.searchFileInput($event)" [selectedFiles]="[]"></app-file-dropzone>
        </ng-container>
        <ng-container *ngIf="this.searchFileSelection == 'DAT'">
          <div class="file-upload-dat-dropzones">
            <app-file-dropzone class="dropzone" [allowMultiple]="true"
                               [acceptedFileTypes]="['.dat']"
                               (fileInputEvent)="this.datFileInput($event)" [selectedFiles]="[]"></app-file-dropzone>
            <app-file-dropzone class="dropzone" [allowMultiple]="true"
                               [acceptedFileTypes]="['.fa','.faa','.fasta']"
                               (fileInputEvent)="this.fastaFileInput($event)" [selectedFiles]="[]"></app-file-dropzone>
          </div>
        </ng-container>

      </div>
    </ng-container>
  </form>

  <button mat-raised-button color="accent" [disabled]="(this.buttonDisabled)" (click)="onSubmit()">Submit</button>


  <!-- OLD -->
  <!-- TODO most of the old elements have been deleted already, determine what to do with the batch selector -->
  <!-- Batch-Upload-Selector -->
  <!-- <ng-container *ngIf="this.parentDataItem.type == 'FOLDER'">
      <div class="divider-line">General Parameters</div>
      <div class="input-group mb-3">
          <mat-checkbox [(ngModel)]="intentToUpload" (change)="intentToUploadChange()">Upload data right now?</mat-checkbox>
      </div>
      <div class="input-group mb-3"
          [@detailExpand]="this.fileAmountSelection == 'Single' ? 'expanded' : 'collapsed'">
          <mat-form-field [formGroup]="this.experimentForm" class="input-group-append">
              <mat-label>Experiment Name</mat-label>
              <input type="text" class="form-control custom-select" id="experimentName" formControlName="expName"
                  matInput>
              <mat-error *ngIf="experimentForm.get('expName').errors && experimentForm.get('expName').touched">
                  {{getNameErrorMessage()}}
              </mat-error>
          </mat-form-field>
      </div>
      <div [@detailExpand]="intentToUpload ? 'expanded' : 'collapsed'" class="input-group mb-3">
          <div class="input-group mb-3">
              <div class="input-group-prepend">
                  <span class="input-group-text">Upload Amount</span>
              </div>
              <mat-select class="form-control custom-select" [(value)]="this.fileAmountSelection" (selectionChange)="this.fileAmountSelectionChange()">
                  <mat-option *ngFor="let fileAmount of fileAmountOptions"
                      [value]="fileAmount">{{fileAmount}}</mat-option>
              </mat-select>
          </div>
          <div class="input-group mb-3">
              <div class="input-group-prepend">
                  <span class="input-group-text">Data Type</span>
              </div>
              <div class="form-control custom-select">
                  <span>Search Files</span>
              </div>
          </div>
      </div>
  </ng-container> -->


</div>
